# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Attributes
dirac::SubbandByteIO Class Reference

Subband Dirac-bytestream input/output.

`#include <subband_byteio.h>`

Inheritance diagram for dirac::SubbandByteIO:

List of all members.

## Public Member Functions
| SubbandByteIO (Subband &sub_band, const ByteIO &byteio)
| Constructor.
| SubbandByteIO (Subband &sub_band)
| ~SubbandByteIO ()
| Destructor.
bool | Input ()
| Inputs data from Dirac stream-format.
int | GetBandDataLength () const
| Gets number of bytes in Arith-coded data block.
const std::string | GetBytes ()
| Gets subband bytes in Dirac-bytestream format.
Public Member Functions inherited from dirac::ByteIO
| ByteIO (bool new_stream=true)
| Default constructor.
| ByteIO (const ByteIO &stream_data)
| Constructor.
virtual | ~ByteIO ()
| Destructor.
virtual void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte-stream statistics.
int | GetReadBytePosition () const
| Get position of read stream pointer.
virtual int | GetSize () const
| *Gets size (in bytes)
void | SetByteParams (const ByteIO &byte_io)
| Copies stream source/destination info.
void | ByteAlignOutput ()
| Sync input for byte-alignment.
void | WriteUint (unsigned int value)
| Ouputs an unsigned integer in interleaved exp Golomb format.
void | SetBitsLeft (int left_bits)
| Sets input size in bits.
int | BitsLeft (void)
| Sets input size in bits.

## Private Attributes
Subband & | m_subband
| Sub-band that is inputed/outputed.
int | m_band_data_length
| Number of bytes in arith-coded data block.

## Additional Inherited Members
Protected Member Functions inherited from dirac::ByteIO
bool | CanRead () const
bool | GetBit (unsigned char &c, int pos) const
void | SetBit (unsigned char &c, int pos) const
void | SetBits (unsigned char &c, unsigned char bits) const
void | ByteAlignInput ()
| Sync input for byte-alignment.
bool | ReadBool ()
| Reads boolean value.
bool | ReadBoolB ()
| Reads boolean value - bounded i/o.
int | ReadBit ()
| Reads next bit.
int | ReadBitB ()
| Reads next bit - bounded i/o.
unsigned int | ReadNBits (int count)
| Reads next 'count' bits.
void | InputBytes (char *data, int count)
| Reads from stream.
void | FlushInputB ()
| Flushes the bounde input.
int | ReadSint ()
| Reads a signed integer in interleaved exp-Golomb format *return Signed integer read.
int | ReadSintB ()
| Reads a signed integer in interleaved exp-Golomb format from bounded input *return Signed integer read.
unsigned int | ReadUint ()
| Reads an unsigned integer in interleaved exp Golomb format.
unsigned int | ReadUintB ()
| Reads an unsigned integer in interleaved exp Golomb format from bounded input.
unsigned int | ReadUintLit (const int byte_size)
| Reads a fixed length unsigned integer from the stream in big endian.
unsigned char | InputUnByte ()
| Reads a byte from the stream.
std::string | InputUnString (const int count)
| Reads a series of bytes from a stream.
void | WriteBit (const bool &bit)
| Outputs a bit.
int | WriteNBits (unsigned int val)
| Outputs an unsigned integer.
void | WriteNBits (unsigned int val, int count)
| Outputs an n bit integer.
void | OutputBytes (const std::string &bytes)
| Outputs a series of bytes.
void | OutputCurrentByte ()
| Outputs current byte contents.
void | WriteSint (int val)
| Outputs an integer in Golomb signed integer format.
void | WriteUintLit (const unsigned int &value, const int &length)
| Output unsigned int value in big endian format.
void | RemoveRedundantBytes (const int count)
| Removes portion of byte-stream no longer required.
void | SeekGet (const int offset, std::ios_base::seekdir dir)
Protected Attributes inherited from dirac::ByteIO
std::stringstream * | mp_stream
| Input/output steam.

## Constructor & Destructor Documentation

dirac::SubbandByteIO::SubbandByteIO | ( | Subband & | sub_band,
|  | const ByteIO & | byteio
| ) |  |

Parameters:

  sub_band | Corresponding Subband
  byteio | Source/Destination of data

dirac::SubbandByteIO::SubbandByteIO | ( | Subband & | sub_band | ) |

dirac::SubbandByteIO::~SubbandByteIO | ( |  | ) |

## Member Function Documentation

int dirac::SubbandByteIO::GetBandDataLength | ( |  | ) | const

const std::string dirac::SubbandByteIO::GetBytes | ( |  | ) |
| virtual

Reimplemented from dirac::ByteIO.

bool dirac::SubbandByteIO::Input | ( |  | ) |

## Member Data Documentation

int dirac::SubbandByteIO::m_band_data_length
| private

Subband& dirac::SubbandByteIO::m_subband
| private

The documentation for this class was generated from the following file:

- subband_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.